//SeitenEntfernen_01d.js
// 27.10.2018 / Hans Haesler, Chtelard 52, CH-1018 Lausanne
//DESCRIPTION:Markierte Seiten entfernen

// vorbeugenderweise das Anzeigen von Dialogen aktivieren
app.scriptPreferences.userInteractionLevel = UserInteractionLevels.interactWithAll;

// testen, ob ein Dokument geffnet ist
if (app.documents.length == 0) {
	alert ("Es ist kein Dokument offen.", "Achtung");
	exit();
}

// aktuelles Dokument
var curDoc = app.documents[0];

// die Suchen/Ersetzen-Vorgaben zurcksetzen
app.findTextPreferences = app.changeTextPreferences = null;

// das Suchmuster vorbereiten
app.findTextPreferences.findWhat = "XX,XX";

// die Vorkommen finden und zhlen
var allFound = curDoc.findText();
var nFound   = allFound.length;
var namesArr = [];

// eine Schleife durch die Vorkommen und die Seitennamen auflisten
for (var n=0; n<nFound; n++) {
	var curName = allFound[n].parentTextFrames[0].parentPage.name;
	var isInArr = checkName(namesArr, curName);
	if (!isInArr) {
		namesArr.push(curName);
	}
}

// den Array sortieren ...
namesArr.sort(numSort);
// ... umkehren ...
namesArr.reverse();
// ... und zhlen
var nNames = namesArr.length;

// die Seiten entfernen
for (var p=0; p<nNames; p++) {
	try {
		curDoc.pages.itemByName(namesArr[p]).remove();
	}
	catch (e) {
	}
}

// die Suchen/Ersetzen-Vorgaben zurcksetzen
app.findTextPreferences = app.changeTextPreferences = null;

// das Ende der Aktion verknden
//alert ("Fertig.", "");
var dlog = new Window("palette");
dlog.size = [320,100];
dlog.add("statictext", [80, 100, 320, 116], "Fertig.");
dlog.show();
// eine kleine Pause
$.sleep(999);
// das Fenster schliessen
dlog.close();

// diese Funktion prft, ob sich der Name schon im Array befindet
function checkName(namesArr, curName) {
	for (var n=0; n<namesArr.length; n++) {
		if (namesArr[n] == curName) {
			return true;
		}
	}
	return false;
}

// die Funktion, welche Zahlen-Strings sortiert
function numSort(a, b) {
	return a - b;
}